<?php


class	inputline {
	var	$line = null;
	var	$locate = "";
	var	$parent = null;
	function	inputline($line = "", $locate = "(unknown)") {
		$this->line = $line;
		$this->locate = $locate;
	}
	function	gets() {
		$ret = $this->line;
		$this->line = null;
		return $ret;
	}
	function	ungets($s = "") {
		$this->line = $s.$this->line;
	}
	function	getchunk($terminator = null, $eolenable = 0) {
		if ($terminator === null) {
			$terminator = " \t";
			$eolenable = 1;
		}
		
		$line = $this->gets();
		$ret = "";
		for (;;) {
			if ($line == "") {
				if (($eolenable))
					return $ret;
				$this->ungets($ret);
				return null;
			}
			$c = substr($line, 0, 1);
			$line = substr($line, 1);
			if (strpos($terminator, $c) !== FALSE)
				break;
			$ret .= $c;
		}
		while ($line != "") {
			$c = substr($line, 0, 1);
			if (strpos(" \t", $c) === FALSE)
				break;
			$line = substr($line, 1);
		}
		if ($line != "")
			$this->ungets($line);
		return trim($ret);
	}
	function	getlocate() {
		return $this->locate;
	}
	function	setparent(&$parent) {
		$this->parent =& $parent;
	}
	function	addmessage($message = "") {
		if ($this->parent === null)
			return;
		$this->parent->addmessage($message." in ".$this->locate);
	}
	function	test1() {
		$obj =& new inputline("test");
		assertisa("inputline", $obj)
			->gets_eqf("test");
		$obj =& new inputline("test2");
		assertisa("inputline", $obj)
			->gets_eqf("test2");
		
		$obj =& new inputline("test3", "line#1");
		assertisa("inputline", $obj)
			->gets_eqf("test3")
			->getlocate_eqf("line#1");
		$obj =& new inputline("Hello TDD", "line#2");
		assertisa("inputline", $obj)
			->gets_eqf("Hello TDD")
			->getlocate_eqf("line#2");
		
		$obj =& new inputline("test");
		assertisa("inputline", $obj)
			->gets_eqf("test")
			->getlocate_eqf("(unknown)");
		
		$obj =& new inputline("this is a test.");
		assertisa("inputline", $obj)
			->gets_eqf("this is a test.")
			->gets_eqf(null);
		
		$obj->ungets("abc");
		assertisa("inputline", $obj)
			->gets_eqf("abc");
		
		$obj->ungets("def");
		$obj->ungets("ghi");
		assertisa("inputline", $obj)
			->gets_eqf("ghidef")
			->gets_eqf(null);
		
		$obj =& new inputline("label: decfsz INDF, 1 ");
		asserteq("label", $obj->getchunk(": \t"));
		asserteq("decfsz INDF, 1 ", $obj->gets());
		
		$obj =& new inputline("label decfsz INDF, 1 ");
		asserteq("label", $obj->getchunk(": \t"));
		asserteq("decfsz INDF, 1 ", $obj->gets());
		
		$obj =& new inputline(" decfsz INDF, 1 ");
		asserteq("", $obj->getchunk(": \t"));
		asserteq("decfsz INDF, 1 ", $obj->gets());
		
		$obj =& new inputline("label:");
		asserteq("label", $obj->getchunk(": \t"));
		asserteq(null, $obj->gets());
		
		$obj =& new inputline("label");
		asserteq("label", $obj->getchunk(": \t", 1));
		asserteq(null, $obj->gets());
		
		$obj =& new inputline("label: decfsz INDF, 1 ");
		asserteq("label", $obj->getchunk(": \t"));
		asserteq("decfsz", $obj->getchunk());
		asserteq("INDF, 1 ", $obj->gets());
		
		$obj =& new inputline("label: clrwdt");
		asserteq("label", $obj->getchunk(": \t"));
		asserteq("clrwdt", $obj->getchunk());
		asserteq(null, $obj->gets());
		
		$obj =& new inputline("label: decfsz INDF, 1 ");
		asserteq("label", $obj->getchunk(": \t"));
		asserteq("decfsz", $obj->getchunk());
		asserteq("INDF", $obj->getchunk(","));
		asserteq("1 ", $obj->gets());
		
		$obj =& new inputline("label: decfsz INDF");
		asserteq("label", $obj->getchunk(": \t"));
		asserteq("decfsz", $obj->getchunk());
		asserteq(null, $obj->getchunk(","));
		asserteq("INDF", $obj->gets());
		
		$obj =& new inputline("label\tdecfsz\tINDF\t,\t1\t");
		asserteq("label", $obj->getchunk(": \t"));
		asserteq("decfsz", $obj->getchunk());
		asserteq("INDF", $obj->getchunk(","));
		asserteq("1", $obj->getchunk());
		asserteq(null, $obj->gets());
		
		$obj =& new inputline();
		asserteq(null, $obj->parent);
		$obj2 =& new inputline();
		$obj->setparent($obj2);
		asserteq($obj2, $obj->parent);
		
		$obj =& new inputline();
		$obj->addmessage("dummy");
		
	}
}


class	inputbuffer {
	var	$linelist;
	var	$message = null;
	function	inputbuffer() {
		$this->linelist = array();
		$this->message = array();
	}
	function	iseof() {
		if (count($this->linelist) == 0)
			return 1;
		return 0;
	}
	function	addcontents($contents, $name = "(unknown)", $startnumber = 1) {
		$a = array();
		foreach (split("\r|\n|\r\n", $contents) as $s) {
			$obj =& new inputline($s, $name." #".($startnumber++));
			$obj->setparent($this);
			$a[] =& $obj;
		}
		array_splice($this->linelist, 0, 0, $a);
	}
	function	&getline() {
		$obj =& $this->linelist[0];
		array_shift($this->linelist);
		return $obj;
	}
	function	getmessage() {
		if (count($this->message) <= 0)
			return null;
		return implode("\n", $this->message);
	}
	function	addmessage($s = "") {
		$this->message[] = $s;
	}
	function	test1() {
		$obj =& new inputbuffer();
		assertisa("inputbuffer", $obj)
			->iseof_eqf(1);
		
		$obj->addcontents("test1\ntest2\n");
		assertisa("inputline", $obj->getline())
			->gets_eqf("test1");
		assertisa("inputline", $obj->getline())
			->gets_eqf("test2");
#			->getlocate_eqf("(unknown)");
		assertisa("inputline", $obj->getline())
			->gets_eqf("");
		
		$obj->addcontents("test3\ntest4\n");
		asserteq(0, $obj->iseof());
		assertisa("inputline", $obj->getline())
			->gets_eqf("test3");
		asserteq(0, $obj->iseof());
		assertisa("inputline", $obj->getline())
			->gets_eqf("test4");
		asserteq(0, $obj->iseof());
		assertisa("inputline", $obj->getline())
			->gets_eqf("");
		asserteq(1, $obj->iseof());
		
		$obj->addcontents("test5\ntest6\n", "testfile.txt");
		assertisa("inputline", $obj->getline())
			->getlocate_eqf("testfile.txt #1");
		assertisa("inputline", $obj->getline())
			->getlocate_eqf("testfile.txt #2");
		assertisa("inputline", $obj->getline())
			->gets_eqf("");
		
		$obj->addcontents("test7\ntest8");
		assertisa("inputline", $obj->getline())
			->gets_eqf("test7");
		$obj->addcontents("test9\ntest10");
		assertisa("inputline", $obj->getline())
			->gets_eqf("test9");
		assertisa("inputline", $obj->getline())
			->gets_eqf("test10");
		assertisa("inputline", $obj->getline())
			->gets_eqf("test8");
		asserteq(1, $obj->iseof());
		
		$obj =& new inputbuffer();
		asserteq(null, $obj->getmessage());
		$obj->addmessage("error1");
		asserteq("error1", $obj->getmessage());
		$obj->addmessage("error2");
		asserteq("error1\nerror2", $obj->getmessage());
		
		$obj->addcontents("test9", "testfile2.txt");
		$line =& $obj->getline();
		asserteq($obj, $line->parent);
		$line->addmessage("error3");
		asserteq("error1\nerror2\nerror3 in testfile2.txt #1", $obj->getmessage());
		
		$obj->addcontents("test10\ntest11", "testfile3.txt");
		$line =& $obj->getline();
		$line =& $obj->getline();
		$line->addmessage("error4");
		asserteq("error1\nerror2\nerror3 in testfile2.txt #1\nerror4 in testfile3.txt #2", $obj->getmessage());
		
	}
}


class	commentlessinputbuffer extends inputbuffer {
	function	addcontents($contents, $name = "(unknown)", $startnumber = 1) {
		$a = array();
		foreach (split("\r|\n|\r\n", $contents) as $s) {
			if (($pos = strpos($s, ";")) !== FALSE)
				$s = substr($s, 0, $pos);
			$a[] =& new inputline($s, $name." #".($startnumber++));
		}
		array_splice($this->linelist, 0, 0, $a);
	}
	function	test1() {
		$obj =& new commentlessinputbuffer();
		$obj->addcontents("line;comment");
		assertisa("inputline", $obj->getline())
			->gets_eqf("line");
	}
}


class	outputbuffer {
	var	$memory;
	function	outputbuffer() {
		$this->memory = array();
	}
	function	getdump() {
		ksort($this->memory);
		$s = "";
		$beforeaddr = null;
		foreach ($this->memory as $addr => $data) {
			if ($beforeaddr !== $addr - 1) {
				if ($beforeaddr !== null)
					$s .= "\n";
				$s .= sprintf("%04x :", $addr);
			}
			$s .= sprintf(" %04x", $data);
			if (($addr & 7) == 7)
				$beforeaddr = -1;
			else
				$beforeaddr = $addr;
		}
		return $s;
	}
	function	write($addr = 0, $data = 0) {
		if (@$this->memory[$addr] !== null)
			return -1;
		$this->memory[$addr] = $data;
		return 0;
	}
	function	test1() {
		$obj =& new outputbuffer();
		asserteq("", $obj->getdump());
		$obj->write(0, 0);
		asserteq("0000 : 0000", $obj->getdump());
		$obj->write(1, 0xffff);
		asserteq("0000 : 0000 ffff", $obj->getdump());
		$obj->write(3, 0x1234);
		asserteq("0000 : 0000 ffff\n0003 : 1234", $obj->getdump());
		asserteq(0, $obj->write(4, 0x0001));
		asserteq(-1, $obj->write(4, 0x0002));
		asserteq(0, $obj->write(2, 0x0010));
		asserteq(0, $obj->write(5, 0x0020));
		asserteq(0, $obj->write(6, 0x0030));
		asserteq(0, $obj->write(7, 0x0040));
		asserteq(0, $obj->write(8, 0x0050));
		asserteq("0000 : 0000 ffff 0010 1234 0001 0020 0030 0040\n0008 : 0050", $obj->getdump());
		
		$obj =& new outputbuffer();
		asserteq(0, $obj->write(1, 0xffff));
		asserteq(0, $obj->write(2, 0x0010));
		asserteq(0, $obj->write(3, 0x1234));
		asserteq(0, $obj->write(4, 0x0001));
		asserteq(0, $obj->write(5, 0x0020));
		asserteq(0, $obj->write(6, 0x0030));
		asserteq(0, $obj->write(7, 0x0040));
		asserteq(0, $obj->write(8, 0x0050));
		asserteq("0001 : ffff 0010 1234 0001 0020 0030 0040\n0008 : 0050", $obj->getdump());
	}
}


class	labeltable {
	var	$table;
	function	labeltable() {
		$this->table = array("$" => 0);
	}
	function	isvalidname($name) {
		if ($name == "$")
			return TRUE;
		return ereg('^[_a-zA-Z][_0-9A-Za-z]*$', $name);
	}
	function	getlabel($name) {
		if (!$this->isvalidname($name))
			return FALSE;
		return @$this->table[$name];
	}
	function	setlabel($name, $val, $force = 0) {
		if (!$this->isvalidname($name))
			return -2;
		if (($force == 0)&&(@$this->table[$name] !== null))
			return -1;
		$this->table[$name] = $val;
		return 0;
	}
	function	test1() {
		$obj =& new labeltable();
		asserteq(0, $obj->getlabel("$"));
		asserteq(null, $obj->getlabel("a"));
		asserteq(0, $obj->setlabel("a", 1));
		asserteq(1, $obj->getlabel("a"));
		asserteq(-1, $obj->setlabel("a", 2));
		
		asserteq(-1, $obj->setlabel("$", 1));
		asserteq(0, $obj->getlabel("$"));
		asserteq(0, $obj->setlabel("$", 1, 1));
		asserteq(1, $obj->getlabel("$"));
		
		$obj =& new labeltable();
		asserteq(-2, $obj->setlabel("0", 0));
		asserteq(-2, $obj->setlabel("-1", 0));
		asserteq(-2, $obj->setlabel("0x123", 0));
		asserteq(-2, $obj->setlabel("a$", 0));
		
		asserteq(null, $obj->getlabel("a"));
		asserteq(FALSE, $obj->getlabel("-1"));
		
	}
}


class	opcode {
	var	$basecode;
	var	$operand = null;
#	var	$locate = null;
	var	$line = null;
	var	$operandcount = -1;
	var	$pc = -1;
	var	$labeltable = null;
	function	opcode($basecode = 0) {
		$this->basecode = $basecode;
	}
	function	parseoperand(&$line) {
#		$this->locate = $line->getlocate();
		$this->line =& $line;
		
		if ($this->operandcount <= 0) {
			if ($line->gets() != "") {
				$line->addmessage("too many operand");
				return -1;
			}
			return 0;
		}
		$array = array();
		for ($i=1; $i<$this->operandcount; $i++) {
			if (($val = $line->getchunk(",")) == "") {
				$line->addmessage("no enough operand");
				return -1;
			}
			$array[] = $val;
		}
		if (($val = $line->getchunk()) == "") {
			$line->addmessage("no enough operand");
			return -1;
		}
		$array[] = $val;
		if ($line->gets() != "") {
			$line->addmessage("too many operand");
			return -1;
		}
		$this->operand = $array;
		return 0;
	}
	function	incrementpc($size = 1) {
		$this->labeltable->setlabel("$", $this->pc + $size, 1);
	}
	function	setpclabel($label = null) {
		$this->pc = $this->labeltable->getlabel("$");
		if ($label !== null)
			return $this->labeltable->setlabel($label, $this->pc);
		return 0;
	}
	function	&factory(&$line, &$labeltable, $label = null) {
		$null = null;
		
		$classname = get_class($this);
		$obj =& new $classname($this->basecode);
		if ($obj->parseoperand($line) < 0)
			return $null;
		$obj->labeltable =& $labeltable;
		
		switch ($obj->setpclabel($label)) {
			case	0:
				break;
			default:
			case	-1:
				$line->addmessage("multiple label defined");
				return $null;
			case	-2:
				$line->addmessage("invalid label characters");
				return $null;
		}
		$obj->incrementpc();
		
		return $obj;
	}
#	function	getlocate() {
#		return $this->locate;
#	}
	function	getcode() {
		return $this->basecode;
	}
	function	write(&$buf) {
		if (($code = $this->getcode()) === null)
			return -1;
		if ($buf->write($this->pc, $code) >= 0)
			return 0;
		if ($this->line !== null)
			$this->line->addmessage("memory address conflicted");
		return -1;
	}
	function	evaloperand($s) {
		if (is_int($s))
			$s = @$this->operand[$s];
		for (;;) {
			if (ereg('^-?0[0-9]+$', $s))
				return intval($s, 0);
			if (ereg('^-?[0-9]+$', $s))
				return $s + 0;
			if (ereg('^-?0x[0-9A-Fa-f]+$', $s))
				return intval($s, 0);
			
			$val = $this->labeltable->getlabel($s);
			if (($val !== null)&&($val !== FALSE)) {
				$s = $val;
				continue;
			}
			if ($this->line !== null)
				$this->line->addmessage("undefined label");
			return null;
		}
	}
	function	test1() {
		$this->labeltable =& new labeltable();
		
		asserteq(0, $this->evaloperand("0"));
		asserteq(1, $this->evaloperand("1"));
		asserteq(null, $this->evaloperand(""));
		asserteq(18, $this->evaloperand("0x12"));
		asserteq(-1, $this->evaloperand("-1"));
		asserteq(-18, $this->evaloperand("-0x12"));
		asserteq(9, $this->evaloperand("011"));
		asserteq(-9, $this->evaloperand("-011"));
		
		asserteq(0, $this->evaloperand("$"));
		asserteq(null, $this->evaloperand("a0"));
		$this->labeltable->setlabel("a0", 3);
		asserteq(3, $this->evaloperand("a0"));
		
		$this->labeltable =& new labeltable();
		asserteq(0, $this->setpclabel("a0"));
		asserteq(-1, $this->setpclabel("a0"));
		asserteq(-2, $this->setpclabel("0"));
		
		
	}
}


class	opcode3bit extends opcode {
	var	$operandcount = 1;
	function	getcode() {
		if (($val1 = $this->evaloperand(0)) === null)
			return null;
		return $this->basecode | ($val1 & 0x7ff);
	}
	function	test1() {
		$obj =& new opcode3bit(0);
		$line =& new inputline("1");
		asserteq(0, $obj->parseoperand($line));
		asserteqa("1", $obj->operand);
		
		$obj =& new opcode3bit(0);
		$line =& new inputline("2");
		asserteq(0, $obj->parseoperand($line));
		asserteqa("2", $obj->operand);
		
		$obj =& new opcode3bit(0);
		$line =& new inputline("");
		asserteq(-1, $obj->parseoperand($line));
		asserteqa(null, $obj->operand);
		
		$obj =& new opcode3bit(0);
		$line =& new inputline("3");
		$line->gets();
		$obj->parseoperand($line);
		asserteqa(null, $obj->operand);
		
		$obj =& new opcode3bit(0);
		$line =& new inputline("1, 2");
		asserteq(-1, $obj->parseoperand($line));
		asserteqa(null, $obj->operand);
		
		$obj =& new opcode3bit(0);
		$line =& new inputline("4 ");
		asserteq(0, $obj->parseoperand($line));
		asserteqa("4", $obj->operand);
		
		$labeltable =& new labeltable();
		
		$obj =& new opcode3bit(0x2000);
		assertisa("opcode", $obj)
			->basecode_eq(0x2000);
		$obj =& new opcode3bit(0x2800);
		assertisa("opcode", $obj)
			->basecode_eq(0x2800);
		$line =& new inputline("a");
		$obj2 =& $obj->factory($line, $labeltable);
		assertisa("opcode3bit", $obj2)
			->basecode_eq(0x2800);
		
		$obj =& new opcode3bit(0x2000);
		assertisa("opcode", $obj)
			->basecode_eq(0x2000);
		$line =& new inputline("b");
		$obj2 =& $obj->factory($line, $labeltable);
		assertisa("opcode3bit", $obj2)
			->basecode_eq(0x2000);
		
		$line =& new inputline("1");
		$obj2 =& $obj->factory($line, $labeltable);
		assertisa("opcode3bit", $obj2)
			->basecode_eq(0x2000)
			->operand_eqa("1");
		
		$line =& new inputline("2");
		$obj2 =& $obj->factory($line, $labeltable);
		assertisa("opcode3bit", $obj2)
			->basecode_eq(0x2000)
			->operand_eqa("2");
		
		$line =& new inputline("");
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(null, $obj2);
		
		$line =& new inputline("1, 2");
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(null, $obj2);
		
#		$line =& new inputline("x", "locate1");
#		$obj2 =& $obj->factory($line, $labeltable);
#		assertisa("opcode3bit", $obj2)
#			->getlocate_eqf("locate1");
		
#		$line =& new inputline("y", "locate2");
#		$obj2 =& $obj->factory($line, $labeltable);
#		assertisa("opcode3bit", $obj2)
#			->getlocate_eqf("locate2");
		
		$labeltable =& new labeltable();
		$obj =& new opcode3bit(0x2000);
		
		$line =& new inputline("x");
		$obj2 =& $obj->factory($line, $labeltable);
		$labeltable->setlabel("x", 12);
		assertisa("opcode", $obj2)
			->getcode_eqf(0x200c);
		
		$obj =& new opcode3bit(0);
		$buf =& new inputbuffer();
		$line =& new inputline("2");
		$line->setparent($buf);
		asserteq(0, $obj->parseoperand($line));
		asserteqa("2", $obj->operand);
		asserteq(null, $buf->getmessage());
		
		$obj =& new opcode3bit(0);
		$buf =& new inputbuffer();
		$line =& new inputline("");
		$line->setparent($buf);
		$obj->parseoperand($line);
		asserteq("no enough operand in (unknown)", $buf->getmessage());
		
		$obj =& new opcode3bit(0);
		$line =& new inputline("3");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$line->gets();
		$obj->parseoperand($line);
		asserteq("no enough operand in (unknown)", $buf->getmessage());
		
		$obj =& new opcode3bit(0);
		$line =& new inputline("1, 2");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->parseoperand($line);
		asserteq("too many operand in (unknown)", $buf->getmessage());
		
		$obj =& new opcode3bit(0);
		$labeltable =& new labeltable();
		$line =& new inputline("1");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->factory($line, $labeltable, "a0");
		asserteq(null, $buf->getmessage());
		
		$line =& new inputline("1");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->factory($line, $labeltable, "a0");
		asserteq("multiple label defined in (unknown)", $buf->getmessage());
		
		$line =& new inputline("1");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->factory($line, $labeltable, "-");
		asserteq("invalid label characters in (unknown)", $buf->getmessage());
		
		$labeltable =& new labeltable();
		$outputbuffer =& new outputbuffer();
		$line =& new inputline("work0");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(null, $obj2->getcode());
		
		$labeltable =& new labeltable();
		$outputbuffer =& new outputbuffer();
		$line =& new inputline("work0");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(-1, $obj2->write($outputbuffer));
		asserteq("undefined label in (unknown)", $buf->getmessage());
		
	}
}


class	opcode4bit extends opcode {
	var	$operandcount = 2;
	function	getcode() {
		if (($val1 = $this->evaloperand(0)) === null)
			return null;
		if (($val2 = $this->evaloperand(1)) === null)
			return null;
		return $this->basecode | ($val1 & 0x7f) | (($val2 & 7) << 7);
	}
	function	test1() {
		$obj =& new opcode4bit();
		
		$line =& new inputline("2, 1");
		asserteq(0, $obj->parseoperand($line));
		asserteqa("2|1", $obj->operand);
		
		$line =& new inputline("3, 0");
		asserteq(0, $obj->parseoperand($line));
		asserteqa("3|0", $obj->operand);
		
		$line =& new inputline("3");
		asserteq(-1, $obj->parseoperand($line));
		
		$line =& new inputline("");
		asserteq(-1, $obj->parseoperand($line));
		
		$line =& new inputline("3,");
		asserteq(-1, $obj->parseoperand($line));
		
		$labeltable =& new labeltable();
		
		$line =& new inputline("3, 1");
		$obj2 =& $obj->factory($line, $labeltable);
		assertisa("opcode", $obj2)
			->operand_eqa("3|1");
		
		$line =& new inputline("4");
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(null, $obj2);
		
		$labeltable =& new labeltable();
		$obj =& new opcode4bit(0x3000);
		
		$line =& new inputline("a, bit");
		$obj2 =& $obj->factory($line, $labeltable);
		$labeltable->setlabel("a", "0x40");
		$labeltable->setlabel("bit", "-1");
		assertisa("opcode", $obj2)
			->getcode_eqf(0x33c0);
		
		$obj =& new opcode4bit();
		$line =& new inputline("3");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->parseoperand($line);
		asserteq("no enough operand in (unknown)", $buf->getmessage());
		
		$obj =& new opcode4bit();
		$line =& new inputline("");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->parseoperand($line);
		asserteq("no enough operand in (unknown)", $buf->getmessage());
		
		$obj =& new opcode4bit();
		$line =& new inputline("1, 2, 3");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->parseoperand($line);
		asserteq("too many operand in (unknown)", $buf->getmessage());
		
		$labeltable =& new labeltable();
		$outputbuffer =& new outputbuffer();
		$line =& new inputline("work0, 0");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(-1, $obj2->write($outputbuffer));
		asserteq("undefined label in (unknown)", $buf->getmessage());
		
		$labeltable =& new labeltable();
		$outputbuffer =& new outputbuffer();
		$line =& new inputline("0, work0");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(-1, $obj2->write($outputbuffer));
		asserteq("undefined label in (unknown)", $buf->getmessage());
		
	}
}


class	opcode6bitreg extends opcode {
	var	$operandcount = 2;
	function	getcode() {
		if (($val1 = $this->evaloperand(0)) === null)
			return null;
		if (($val2 = $this->evaloperand(1)) === null)
			return null;
		return $this->basecode | ($val1 & 0x7f) | (($val2)? 0x80 : 0);
	}
	function	test1() {
		$labeltable =& new labeltable();
		$obj =& new opcode6bitreg(0);
		
		$line =& new inputline("a, bit");
		$obj2 =& $obj->factory($line, $labeltable);
		$labeltable->setlabel("a", "0x60");
		$labeltable->setlabel("bit", "-1");
		assertisa("opcode", $obj2)
			->getcode_eqf(0x00e0);
		
		$labeltable =& new labeltable();
		$outputbuffer =& new outputbuffer();
		$line =& new inputline("work0, 0");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(-1, $obj2->write($outputbuffer));
		asserteq("undefined label in (unknown)", $buf->getmessage());
		
		$labeltable =& new labeltable();
		$outputbuffer =& new outputbuffer();
		$line =& new inputline("0, work0");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(-1, $obj2->write($outputbuffer));
		asserteq("undefined label in (unknown)", $buf->getmessage());
		
	}
}


class	opcode6bitstore extends opcode {
	var	$operandcount = 1;
	function	getcode() {
		if (($val1 = $this->evaloperand(0)) === null)
			return null;
		return $this->basecode | ($val1 & 0x7f);
	}
	function	test1() {
		$labeltable =& new labeltable();
		$obj =& new opcode6bitstore(0);
		
		$line =& new inputline("bin2hex");
		$obj2 =& $obj->factory($line, $labeltable);
		$labeltable->setlabel("bin2hex", "0xff");
		assertisa("opcode", $obj2)
			->getcode_eqf(0x007f);
		
		$labeltable =& new labeltable();
		$outputbuffer =& new outputbuffer();
		$line =& new inputline("work0");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(-1, $obj2->write($outputbuffer));
		asserteq("undefined label in (unknown)", $buf->getmessage());
		
	}
}


class	opcode6bitimm extends opcode {
	var	$operandcount = 1;
	function	getcode() {
		if (($val1 = $this->evaloperand(0)) === null)
			return null;
		return $this->basecode | ($val1 & 0xff);
	}
	function	test1() {
		$labeltable =& new labeltable();
		$obj =& new opcode6bitimm(0);
		
		$line =& new inputline("bin2hex");
		$obj2 =& $obj->factory($line, $labeltable);
		$labeltable->setlabel("bin2hex", "0x123");
		assertisa("opcode", $obj2)
			->getcode_eqf(0x0023);
		
		$labeltable =& new labeltable();
		$outputbuffer =& new outputbuffer();
		$line =& new inputline("work0");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj2 =& $obj->factory($line, $labeltable);
		asserteq(-1, $obj2->write($outputbuffer));
		asserteq("undefined label in (unknown)", $buf->getmessage());
		
	}
}


class	opcode14bit extends opcode {
	var	$operandcount = 0;
	function	test1() {
		$obj =& new opcode14bit();
		
		$line =& new inputline("");
		asserteq(0, $obj->parseoperand($line));
		asserteqa(null, $obj->operand);
		
		$line =& new inputline("1");
		asserteq(-1, $obj->parseoperand($line));
		
		$line =& new inputline("1");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->parseoperand($line);
		asserteq("too many operand in (unknown)", $buf->getmessage());
		
	}
}


class	pseudocode extends opcode {
	function	write(&$buf) {
		return 0;
	}
}


class	pseudocode_org extends pseudocode {
	var	$operandcount = 1;
	function	&factory(&$line, &$labeltable, $label = null) {
		$obj =& parent::factory($line, $labeltable, $label);
		if ($obj === null)
			return $obj;
		$val = $obj->evaloperand(0);
		$labeltable->setlabel("$", $val, 1);
		if ($label !== null)
			$labeltable->setlabel($label, $val, 1);
		return $obj;
	}
	function	test1() {
		$obj =& new pseudocode_org();
		$line =& new inputline("");
		asserteq(-1, $obj->parseoperand($line));
		$line =& new inputline("0x100");
		asserteq(0, $obj->parseoperand($line));
		
		$labeltable =& new labeltable();
		$buf =& new outputbuffer();
		
		$line =& new inputline("0x120");
		$obj2 =& $obj->factory($line, $labeltable);
		assertisa("pseudocode", $obj2);
		asserteq(0x120, $labeltable->getlabel("$"));
		asserteq(null, $labeltable->getlabel("main"));
		asserteq(0, $obj2->write($buf));
		asserteq("", $buf->getdump());
		
		$labeltable =& new labeltable();
		
		$line =& new inputline("0x120");
		$obj2 =& $obj->factory($line, $labeltable, "main");
		assertisa("pseudocode", $obj2);
		asserteq(0x120, $labeltable->getlabel("$"));
		asserteq(0x120, $labeltable->getlabel("main"));
		asserteq(0, $obj2->write($buf));
		asserteq("", $buf->getdump());
		
		$labeltable =& new labeltable();
		$line =& new inputline("0x120");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->factory($line, $labeltable, "main");
		asserteq(null, $buf->getmessage());
		
		$line =& new inputline("0x140");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->factory($line, $labeltable, "main");
		asserteq("multiple label defined in (unknown)", $buf->getmessage());
		
	}
}


class	pseudocode_equ extends pseudocode {
	var	$operandcount = 1;
	function	&factory(&$line, &$labeltable, $label = null) {
		$obj =& parent::factory($line, $labeltable, $label);
		$val = $obj->evaloperand(0);
		if ($label !== null) {
			switch ($labeltable->setlabel($label, $val)) {
				case	0:
					break;
				default:
				case	-1:
					$line->addmessage("multiple label defined");
					return $null;
				case	-2:
					$line->addmessage("invalid label characters");
					return $null;
			}
		}
		return $obj;
	}
	function	incrementpc($size = 1) {
	}
	function	setpclabel($label = null) {
		return 0;
	}
	function	test1() {
		$obj =& new pseudocode_equ();
		$line =& new inputline("");
		asserteq(-1, $obj->parseoperand($line));
		$line =& new inputline("0x100");
		asserteq(0, $obj->parseoperand($line));
		
		$labeltable =& new labeltable();
		$labeltable->setlabel("$", 0x20, 1);
		$buf =& new outputbuffer();
		
		$line =& new inputline("0x50");
		$obj2 =& $obj->factory($line, $labeltable);
		assertisa("pseudocode", $obj2);
		asserteq(0x20, $labeltable->getlabel("$"));
		asserteq(null, $labeltable->getlabel("work0"));
		asserteq(0, $obj2->write($buf));
		asserteq("", $buf->getdump());
		
		$labeltable =& new labeltable();
		$labeltable->setlabel("$", 0x20, 1);
		
		$line =& new inputline("0x60");
		$obj2 =& $obj->factory($line, $labeltable, "work0");
		assertisa("pseudocode", $obj2);
		asserteq(0x20, $labeltable->getlabel("$"));
		asserteq(0x60, $labeltable->getlabel("work0"));
		asserteq(0, $obj2->write($buf));
		asserteq("", $buf->getdump());
		
		asserteq(0, $this->setpclabel());
		
		$labeltable =& new labeltable();
		$line =& new inputline("0x20");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->factory($line, $labeltable, "work1");
		asserteq(null, $buf->getmessage());
		
		$line =& new inputline("0x21");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->factory($line, $labeltable, "work1");
		asserteq("multiple label defined in (unknown)", $buf->getmessage());
		
		$line =& new inputline("0x21");
		$buf =& new inputbuffer();
		$line->setparent($buf);
		$obj->factory($line, $labeltable, "-");
		asserteq("invalid label characters in (unknown)", $buf->getmessage());
		
	}
}


class	pseudocode_null extends pseudocode {
	function	incrementpc($size = 1) {
	}
	function	test1() {
		$obj =& new pseudocode_null();
		$line =& new inputline("0x100");
		asserteq(-1, $obj->parseoperand($line));
		$line =& new inputline("");
		asserteq(0, $obj->parseoperand($line));
		
		$labeltable =& new labeltable();
		$buf =& new outputbuffer();
		$line =& new inputline("");
		
		$labeltable->setlabel("$", 0x123, 1);
		asserteq(0x123, $labeltable->getlabel("$"));
		$obj2 =& $obj->factory($line, $labeltable);
		assertisa("pseudocode", $obj2);
		asserteq(0x123, $labeltable->getlabel("$"));
		asserteq(0, $obj2->write($buf));
		asserteq("", $buf->getdump());
		
	}
}


$opcodetable = array(
	"nop" => new opcode14bit(0x0000), 
	"return" => new opcode14bit(0x0008), 
	"retfie" => new opcode14bit(0x009), 
	"sleep" => new opcode14bit(0x0063), 
	"clrwdt" => new opcode14bit(0x0064), 
	"clrw" => new opcode14bit(0x0100), 
	"movwf" => new opcode6bitstore(0x0080), 
	"clrf" => new opcode6bitstore(0x0180), 
	"subwf" => new opcode6bitreg(0x0200), 
	"decf" => new opcode6bitreg(0x0300), 
	"iorwf" => new opcode6bitreg(0x0400), 
	"andwf" => new opcode6bitreg(0x0500), 
	"xorwf" => new opcode6bitreg(0x0600), 
	"addwf" => new opcode6bitreg(0x0700), 
	"movf" => new opcode6bitreg(0x0800), 
	"comf" => new opcode6bitreg(0x0900), 
	"incf" => new opcode6bitreg(0x0a00), 
	"decfsz" => new opcode6bitreg(0x0b00), 
	"rrf" => new opcode6bitreg(0x0c00), 
	"rlf" => new opcode6bitreg(0x0d00), 
	"swapf" => new opcode6bitreg(0x0e00), 
	"incfsz" => new opcode6bitreg(0x0f00), 
	"bcf" => new opcode4bit(0x1000), 
	"bsf" => new opcode4bit(0x1400), 
	"btfsc" => new opcode4bit(0x1800), 
	"btfss" => new opcode4bit(0x1c00), 
	"call" => new opcode3bit(0x2000), 
	"goto" => new opcode3bit(0x2800), 
	"movlw" => new opcode6bitimm(0x3000), 
	"retlw" => new opcode6bitimm(0x3400), 
	"iorlw" => new opcode6bitimm(0x3800), 
	"andlw" => new opcode6bitimm(0x3900), 
	"xorlw" => new opcode6bitimm(0x3a00), 
	"sublw" => new opcode6bitimm(0x3c00), 
	"addlw" => new opcode6bitimm(0x3e00), 
	"org" => new pseudocode_org(), 
	"equ" => new pseudocode_equ(), 
	"" => new pseudocode_null()
);


function	&opcodefactory(&$line, &$labeltable, $label = null) {
	global	$opcodetable;
	
	$null = null;
	
	$s = $line->getchunk();
	if (@$opcodetable[$s] === null) {
		$line->addmessage("invalid opcode");
		return $null;
	}
	
	$obj =& $opcodetable[$s]->factory($line, $labeltable, $label);
	return $obj;
}
function	test1_opcodefactory() {
	$labeltable =& new labeltable();
	$buf =& new outputbuffer();
	
	$line =& new inputline("-");
	asserteq(null, opcodefactory($line, $labeltable));
	
	$line =& new inputline("nop");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode14bit", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 0000", $buf->getdump());
	
	$line =& new inputline("clrwdt");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode14bit", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 0000 0064", $buf->getdump());
	
	$line =& new inputline("movwf 1");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode6bitstore", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 0000 0064 0081", $buf->getdump());
	
	$line =& new inputline("movwf 65535");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode6bitstore", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 0000 0064 0081 00ff", $buf->getdump());
	
	$line =& new inputline("decf 4, 0");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode6bitreg", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 0000 0064 0081 00ff 0304", $buf->getdump());
	
	$line =& new inputline("andwf 5, 1");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode6bitreg", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 0000 0064 0081 00ff 0304 0585", $buf->getdump());
	
	$labeltable =& new labeltable();
	$buf =& new outputbuffer();
	
	$line =& new inputline("bcf 6, 3");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode4bit", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 1186", $buf->getdump());
	
	$line =& new inputline("btfss 7, 4");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode4bit", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 1186 1e07", $buf->getdump());
	
	$line =& new inputline("bsf 65535, 0");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode4bit", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 1186 1e07 147f", $buf->getdump());
	
	$line =& new inputline("btfsc 0, 65535");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode4bit", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 1186 1e07 147f 1b80", $buf->getdump());
	
	$line =& new inputline("goto 8");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode3bit", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 1186 1e07 147f 1b80 2808", $buf->getdump());
	
	$line =& new inputline("call 65535");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode3bit", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 1186 1e07 147f 1b80 2808 27ff", $buf->getdump());
	
	$line =& new inputline("movlw\t1");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode6bitimm", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 1186 1e07 147f 1b80 2808 27ff 3001", $buf->getdump());
	
	$line =& new inputline("retlw\t65535");
	$obj =& opcodefactory($line, $labeltable);
	assertisa("opcode6bitimm", $obj);
	asserteq(0, $obj->write($buf));
	asserteq("0000 : 1186 1e07 147f 1b80 2808 27ff 3001 34ff", $buf->getdump());
	
	$labeltable =& new labeltable();
	$labeltable->setlabel("$", 4, 1);
	
	$line =& new inputline("nop");
	$obj =& opcodefactory($line, $labeltable, "test1");
	asserteq(5, $labeltable->getlabel("$"));
	asserteq(4, $labeltable->getlabel("test1"));
	
	$line =& new inputline("org\t0x200");
	$obj =& opcodefactory($line, $labeltable, "test2");
	assertisa("pseudocode_org", $obj);
	asserteq(0x200, $labeltable->getlabel("$"));
	asserteq(0x200, $labeltable->getlabel("test2"));
	
	$line =& new inputline("equ\t0x21");
	$obj =& opcodefactory($line, $labeltable, "work1");
	assertisa("pseudocode_equ", $obj);
	asserteq(0x200, $labeltable->getlabel("$"));
	asserteq(0x21, $labeltable->getlabel("work1"));
	
	$line =& new inputline("");
	$obj =& opcodefactory($line, $labeltable, "test3");
	assertisa("pseudocode_null", $obj);
	asserteq(0x200, $labeltable->getlabel("$"));
	asserteq(0x200, $labeltable->getlabel("test3"));
	
	$labeltable =& new labeltable();
	$buf =& new outputbuffer();
	$line =& new inputline("-");
	$inputbuffer =& new inputbuffer();
	$line->setparent($inputbuffer);
	opcodefactory($line, $labeltable);
	asserteq("invalid opcode in (unknown)", $inputbuffer->getmessage());
	
	$labeltable =& new labeltable();
	$inputbuffer =& new inputbuffer();
	$buf =& new outputbuffer();
	
	$line =& new inputline("nop");
	$line->setparent($inputbuffer);
	$obj =& opcodefactory($line, $labeltable);
	asserteq(0, $obj->write($buf));
	
	$line =& new inputline("org 0");
	$line->setparent($inputbuffer);
	$obj =& opcodefactory($line, $labeltable);
	asserteq(0, $obj->write($buf));
	asserteq(null, $inputbuffer->getmessage());
	
	$line =& new inputline("nop");
	$line->setparent($inputbuffer);
	$obj =& opcodefactory($line, $labeltable);
	asserteq(-1, $obj->write($buf));
	asserteq("memory address conflicted in (unknown)", $inputbuffer->getmessage());
	
}


if (function_exists("asserteq"))
	return;


if (($fn = @$argv[1]) === null)
	die("usage: ".$argv[0]." <filename.asm>\n");

$inputbuffer =& new commentlessinputbuffer();
$inputbuffer->addcontents(file_get_contents($fn), $fn);
$globallabeltable =& new labeltable();
$opcodelist = array();

while (!$inputbuffer->iseof()) {
	$line =& $inputbuffer->getline();
	$label = $line->getchunk(": \t", 1);
	if ($label == "")
		$label = null;
	$obj =& opcodefactory($line, $globallabeltable, $label);
	if ($obj === null)
		die("opcodefactory failed.");
	$opcodelist[] =& $obj;
}

$outputbuffer =& new outputbuffer();
foreach ($opcodelist as $key => $dummy) {
	if (($err = $opcodelist[$key]->write($outputbuffer)) < 0)
		die("write failed.");
}

print $outputbuffer->getdump();

?>
