#! /usr/local/bin/php
<?php


class	run140106 {
	var	$nestlevel = 0;
	var	$testlist = null;
	var	$testcount = 0;
	var	$failedcount = 0;
	var	$currentclass = "";
	var	$currentmethod = "";
	function	run() {
		if ($this->nestlevel++ > 10)
			die("nest too deep.\n");
		if ($this->testlist === null) {
			$this->testlist = array();
			foreach (get_declared_classes() as $classname) {
				foreach (get_class_methods($classname) as $methodname) {
					if (!ereg("^test", $methodname))
						continue;
					$this->testlist[] = array($classname, $methodname);
				}
			}
			$a = get_defined_functions();
			foreach ($a["user"] as $methodname) {
				if (!ereg("^test", $methodname))
					continue;
				$this->testlist[] = array(null, $methodname);
			}
		}
		while (count($this->testlist) > 0) {
			list($classname, $methodname) = array_shift($this->testlist);
			if ($classname === null) {
				$this->currentclass = "(global)";
				$this->currentmethod = $methodname;
				$this->testnumber = 0;
				$methodname();
				continue;
			}
			$this->currentclass = $classname;
			$this->currentmethod = $methodname;
			$this->testnumber = 0;
			$obj =& new $classname();
			$obj->$methodname();
		}
		
		if ($this->failedcount == 0)
			print"\ntest successed.\n";
		else
			printf("\n%d test(s) failed.\n", $this->failedcount);
		die();
	}
	function	successed() {
		$this->testnumber++;
		printf(".");
	}
	function	failed() {
		$this->testnumber++;
		$this->failedcount++;
		printf(" ---- in %s::%s #%d\n", $this->currentclass, $this->currentmethod, $this->testnumber);
		$this->run();	# never return
	}
}
$run140106 =& new run140106();


function	asserteq($expected, $found) {
	global	$run140106;
	
	if ($expected === $found) {
		$run140106->successed();
		return;
	}
	printf("\nexpected: \"%s\"\nfound: \"%s\"\n", $expected, $found);
	$run140106->failed();	# never return
}


function	asserteqa($expected, $found) {
	$s = null;
	if (count($found) > 0)
		$s = implode("|", $found);
	asserteq($expected, $s);
}

class	assertobj {
	var	$target;
	function	assertobj(&$target) {
		$this->target =& $target;
	}
	function	&__call($method, $argv) {
		if (!ereg('^(.*)_([a-z]+)$', $method, $a))
			die("undefined method: ".$method);
		$member = $a[1];
		switch ($a[2]) {
			default:
				die("undefined method: ".$method);
			case	"eq":
				asserteq($argv[0], $this->target->$member);
				return $this;
			case	"eqa":
				asserteqa($argv[0], $this->target->$member);
				return $this;
			case	"eqf":
				asserteq($argv[0], $this->target->$member());
				return $this;
			case	"isa":
				$obj =& assertisa($argv[0], $this->target->$member);
				return $obj;
		}
	}
}


function	&assertisa($expected, &$found) {
	global	$run140106;
	
	if ((is_a($found, $expected))) {
		$run140106->successed();
		$obj =& new assertobj($found);
		return $obj;
	}
	printf("\nexpected: \"%s\"\nfound: \"%s\"\n", $expected, get_class($found));
	$run140106->failed();	# never return
}


require(@$argv[1]);

$run140106->run();	# never return

?>